###################################################
### chunk number 1: 1.historia de encuentros
###################################################
set.seed(111)
N <- 180
p.recap <- 0.5
k=3
celdas<-N*k
a <- matrix(rep(0,celdas),N,k)
for(i in 1:N) a[i,]<-rbinom(k,1,p=p.recap)
lagartija<-data.frame(a)
names(lagartija)<-paste("c", 1:k, sep="")


###################################################
### chunk number 2: 
###################################################
lagartija[1:10,]


###################################################
### chunk number 3: 
###################################################
a<-factorial(10)/(factorial(6)*factorial(4)*(factorial(0)^8))
b<-(1/6)^10


###################################################
### chunk number 4: 
###################################################
a*b


###################################################
### chunk number 5: 
###################################################
a<-factorial(6)/((factorial(1))^6)
b<-(1/6)^6
a*b


###################################################
### chunk number 6: 
###################################################
k.0<-c(0,1,2,3)
num.cap<-apply(lagartija,1,sum)
nk<-table(num.cap)


###################################################
### chunk number 7: 
###################################################
nk


###################################################
### chunk number 8: 
###################################################
llik<-function(param){
p <- plogis(param[1])
-1*sum(nk*log(dbinom(k.0,3,p)))
}
m.lag<-optim(par=0,fn=llik,method="BFGS", hessian=TRUE)


###################################################
### chunk number 9: 
###################################################
p.est<-plogis(m.lag$par) #p estimada
p.se<-sqrt(1/m.lag$hessian) #error estandar
z <- qnorm(0.975) #valores de z al 95%
ic.cru<-m.lag$par + c(-1,1)*z*p.se #Intervalo de confianza
ic <- plogis(ic.cru)
p.est;ic


###################################################
### chunk number 10: 
###################################################
rem0<-which(num.cap==0)
num0<-length(rem0)


###################################################
### chunk number 11: 
###################################################
lag<-lagartija

ifelse(num0==0,lag2<-lag,lag2<-lag[-rem0,])


###################################################
### chunk number 12: 
###################################################

dim(lag);dim(lag2)
num0


###################################################
### chunk number 13: 
###################################################
#Royle & Dorazio (2008)
nvec<-c(57,77,24)
pop.cerrada<-function(parms){
   p<-plogis(parms[1])
   n0<-exp(parms[2])
   N<-sum(nvec) + n0
   cpvec<-dbinom(0:3,3,p)
   -1*(lgamma(N +1 )- lgamma(n0 + 1) + sum(c(n0,nvec)*log(cpvec) ))   
}


###################################################
### chunk number 14: 
###################################################
library(bbmle)
parnames(pop.cerrada) <- c("p","f0")
m1<-mle2(pop.cerrada, start=c(p= 0,f0=3),data=list(nvec=nvec))
intconf<-confint(m1)
plogis(coef(m1)[1])
plogis(intconf)[1,]
exp(coef(m1)[2])
exp(intconf)[2,]


###################################################
### chunk number 15: 
###################################################
plot(profile(m1))


###################################################
### chunk number 16: 
###################################################
library(Rcapture)
cpop<-closedpCI.0(lag2, h = "Poisson")
cpop



###################################################
### chunk number 17: 
###################################################
plotCI(cpop)


